# Create child worker relation with external Id

PUT https://api.letsdeel.com/rest/v2/hris/worker_relations/profile/external/{profileId}/child
Content-Type: application/json

Create child worker relation with external Id.
 **Token scopes**: `profile:write`

Reference: https://developer.deel.com/api/reference/endpoints/worker-relations/upsert-child-worker-relations-external-id

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: Deel HRIS SCIM API
  version: 1.0.0
paths:
  /hris/worker_relations/profile/external/{profileId}/child:
    put:
      operationId: upsert-child-worker-relations-external-id
      summary: Create child worker relation with external Id
      description: |-
        Create child worker relation with external Id.
         **Token scopes**: `profile:write`
      tags:
        - subpackage_workerRelations
      parameters:
        - name: profileId
          in: path
          description: HrisProfile external ID
          required: true
          schema:
            type: string
        - name: Authorization
          in: header
          description: >
            ## Authentication

            The Deel API uses bearer tokens to authenticate requests. All API
            calls must be made over HTTPS — calls over plain HTTP or without
            authentication will fail.


            ```curl

            curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \
              -H 'Authorization: Bearer YOUR-TOKEN-HERE'
            ```


            [Learn more about authentication](/api/authentication)
          required: true
          schema:
            type: string
      responses:
        '204':
          description: Successful operation
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/Worker
                  Relations_upsertChildWorkerRelationsExternalId_Response_204
        '400':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '401':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '403':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '404':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '500':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                data:
                  $ref: >-
                    #/components/schemas/HrisWorkerRelationsProfileExternalProfileIdChildPutRequestBodyContentApplicationJsonSchemaData
servers:
  - url: https://api.letsdeel.com/rest/v2
  - url: https://api-staging.letsdeel.com/rest/v2
components:
  schemas:
    HrisWorkerRelationsProfileExternalProfileIdChildPutRequestBodyContentApplicationJsonSchemaDataChildHrisProfileIdsItems0:
      type: object
      properties:
        relation_external_id:
          type: string
        external_hris_profile_id:
          type: string
      required:
        - relation_external_id
        - external_hris_profile_id
      title: >-
        HrisWorkerRelationsProfileExternalProfileIdChildPutRequestBodyContentApplicationJsonSchemaDataChildHrisProfileIdsItems0
    HrisWorkerRelationsProfileExternalProfileIdChildPutRequestBodyContentApplicationJsonSchemaDataChildHrisProfileIdsItems:
      oneOf:
        - $ref: >-
            #/components/schemas/HrisWorkerRelationsProfileExternalProfileIdChildPutRequestBodyContentApplicationJsonSchemaDataChildHrisProfileIdsItems0
      title: >-
        HrisWorkerRelationsProfileExternalProfileIdChildPutRequestBodyContentApplicationJsonSchemaDataChildHrisProfileIdsItems
    HrisWorkerRelationsProfileExternalProfileIdChildPutRequestBodyContentApplicationJsonSchemaData:
      type: object
      properties:
        child_hris_profile_ids:
          type: array
          items:
            $ref: >-
              #/components/schemas/HrisWorkerRelationsProfileExternalProfileIdChildPutRequestBodyContentApplicationJsonSchemaDataChildHrisProfileIdsItems
        hris_relationship_type_external_id:
          type: string
          format: uuid
      required:
        - child_hris_profile_ids
      title: >-
        HrisWorkerRelationsProfileExternalProfileIdChildPutRequestBodyContentApplicationJsonSchemaData
    Worker Relations_upsertChildWorkerRelationsExternalId_Response_204:
      type: object
      properties: {}
      description: Empty response body
      title: Worker Relations_upsertChildWorkerRelationsExternalId_Response_204
    ApiErrorRequest:
      type: object
      properties:
        method:
          type: string
          description: The HTTP method of the failed request
        url:
          type: string
          description: The relative URL of the failed request
        status:
          type: number
          format: double
          description: The status code of the response
        api_req_id:
          type: string
          description: The request ID of the failed request
        docs:
          type: string
          description: >-
            A link to the official documentation for the requested endpoint
            resource
        source:
          type: string
          description: The source handler which produced the returned error
        code:
          type: number
          format: double
          description: The code of the source handler which produced the returned error
      title: ApiErrorRequest
    ApiError:
      type: object
      properties:
        message:
          type: string
          description: A description of the returned error
        path:
          type: string
          description: The JSON path where input validation failed
      title: ApiError
    ApiErrorContainer:
      type: object
      properties:
        request:
          $ref: '#/components/schemas/ApiErrorRequest'
        errors:
          type: array
          items:
            $ref: '#/components/schemas/ApiError'
      title: ApiErrorContainer
  securitySchemes:
    deelToken:
      type: http
      scheme: bearer
      description: >
        ## Authentication

        The Deel API uses bearer tokens to authenticate requests. All API calls
        must be made over HTTPS — calls over plain HTTP or without
        authentication will fail.


        ```curl

        curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \
          -H 'Authorization: Bearer YOUR-TOKEN-HERE'
        ```


        [Learn more about authentication](/api/authentication)
    oauth2:
      type: http
      scheme: bearer
      description: >-
        Standard OAuth2 security scheme based on
        https://swagger.io/docs/specification/authentication/

```

## SDK Code Examples

```python
import requests

url = "https://api.letsdeel.com/rest/v2/hris/worker_relations/profile/external/profileId/child"

payload = { "body": { "data": {
            "child_hris_profile_ids": [
                {
                    "external_hris_profile_id": "child-hris-12345",
                    "relation_external_id": "relation-67890"
                }
            ],
            "hris_relationship_type_external_id": "3fa85f64-5717-4562-b3fc-2c963f66afa6"
        } } }
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.put(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.letsdeel.com/rest/v2/hris/worker_relations/profile/external/profileId/child';
const options = {
  method: 'PUT',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"body":{"data":{"child_hris_profile_ids":[{"external_hris_profile_id":"child-hris-12345","relation_external_id":"relation-67890"}],"hris_relationship_type_external_id":"3fa85f64-5717-4562-b3fc-2c963f66afa6"}}}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.letsdeel.com/rest/v2/hris/worker_relations/profile/external/profileId/child"

	payload := strings.NewReader("{\n  \"body\": {\n    \"data\": {\n      \"child_hris_profile_ids\": [\n        {\n          \"external_hris_profile_id\": \"child-hris-12345\",\n          \"relation_external_id\": \"relation-67890\"\n        }\n      ],\n      \"hris_relationship_type_external_id\": \"3fa85f64-5717-4562-b3fc-2c963f66afa6\"\n    }\n  }\n}")

	req, _ := http.NewRequest("PUT", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.letsdeel.com/rest/v2/hris/worker_relations/profile/external/profileId/child")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Put.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"body\": {\n    \"data\": {\n      \"child_hris_profile_ids\": [\n        {\n          \"external_hris_profile_id\": \"child-hris-12345\",\n          \"relation_external_id\": \"relation-67890\"\n        }\n      ],\n      \"hris_relationship_type_external_id\": \"3fa85f64-5717-4562-b3fc-2c963f66afa6\"\n    }\n  }\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.put("https://api.letsdeel.com/rest/v2/hris/worker_relations/profile/external/profileId/child")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"body\": {\n    \"data\": {\n      \"child_hris_profile_ids\": [\n        {\n          \"external_hris_profile_id\": \"child-hris-12345\",\n          \"relation_external_id\": \"relation-67890\"\n        }\n      ],\n      \"hris_relationship_type_external_id\": \"3fa85f64-5717-4562-b3fc-2c963f66afa6\"\n    }\n  }\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PUT', 'https://api.letsdeel.com/rest/v2/hris/worker_relations/profile/external/profileId/child', [
  'body' => '{
  "body": {
    "data": {
      "child_hris_profile_ids": [
        {
          "external_hris_profile_id": "child-hris-12345",
          "relation_external_id": "relation-67890"
        }
      ],
      "hris_relationship_type_external_id": "3fa85f64-5717-4562-b3fc-2c963f66afa6"
    }
  }
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.letsdeel.com/rest/v2/hris/worker_relations/profile/external/profileId/child");
var request = new RestRequest(Method.PUT);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"body\": {\n    \"data\": {\n      \"child_hris_profile_ids\": [\n        {\n          \"external_hris_profile_id\": \"child-hris-12345\",\n          \"relation_external_id\": \"relation-67890\"\n        }\n      ],\n      \"hris_relationship_type_external_id\": \"3fa85f64-5717-4562-b3fc-2c963f66afa6\"\n    }\n  }\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = ["body": ["data": [
      "child_hris_profile_ids": [
        [
          "external_hris_profile_id": "child-hris-12345",
          "relation_external_id": "relation-67890"
        ]
      ],
      "hris_relationship_type_external_id": "3fa85f64-5717-4562-b3fc-2c963f66afa6"
    ]]] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.letsdeel.com/rest/v2/hris/worker_relations/profile/external/profileId/child")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PUT"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```